#ifndef __IPTRAP_P_H__
#define __IPTRAP_P_H__ 1

typedef struct IPMask4_ {
	int family;
	unsigned long addr;
	unsigned long mask;
} IPMask4;

typedef struct IPMask6_ {
	int family;
	unsigned char addr[16];
} IPMask6;

typedef union IPMask_ {
	int family;
	IPMask4 ipmask4;
	IPMask6 ipmask6;
} IPMask;

static IPMask ipmasks[MAX_MASKS];
static unsigned int nb_masks;
static struct pollfd polls[MAX_SOCKETS];
static unsigned int nb_sockets;
static signed char v6ready;
static signed char daemonize;
static const char *external_script;

static const char *chain =
#ifdef IPTABLES
	IPTABLES_CHAIN
#elif defined(IPCHAINS)
	IPCHAINS_CHAIN
#else
	""
#endif
	;

static const char *jump =
#ifdef IPTABLES
	IPTABLES_TARGET
#elif defined(IPCHAINS)
	IPCHAINS_TARGET
#else
	""
#endif
	;

#endif
